package com.hzya.frame.nifiapi.operation;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation
 * @Project：fw-nifi
 * @name：BaseNifiOperation
 * @Date：2025/5/21 17:50
 * @Filename：BaseNifiOperation
 */
public interface BaseOperation {
    /**
     * 实例化某个应用（对应nifi流程组id）
     *
     * @param appProcessGroupId        需要复制的流程组id(应用id)，比如Oracle应用id、Mysql应用id
     * @param parentProcessGroupId     流程组id(应用id)的父流程组id
     * @param copyTargetProcessGroupId 指定创建的流程组id
     * @return 返回流程组实例化id
     */
    String instantiateApp(String appProcessGroupId, String parentProcessGroupId, String copyTargetProcessGroupId) throws Exception;
}
