package com.hzya.frame.nifiapi.operation;

import com.hzya.frame.nifiapi.model.joincreatemysqlapp.CreateMysqlApp;
import com.hzya.frame.nifiapi.model.joincreateoracleapp.CreateOracleApp;

/**
 * NiFi应用实例化业务操作接口
 *
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation
 * @Project：fw-nifi
 * @name：NifiOperation
 * @Date：2025/5/21 17:05
 * @Filename：NifiOperation
 */
public interface NifiOperation {
    /**
     * Oracle应用创建并实例化
     * 主要包含一系列nifi接口调用操作，其他应用开发封转类以此类推
     * 1.创建nifi片段
     * 2.把片段实例化
     * 3.修改nifi控制器
     * 4.新建上下文环境参数
     * 5.绑定上下文环境参数到流程组
     * 6.激活当前流程组内的所有控制器服务
     *
     * @param createOracleApp 封装创建Oracle应用所需要的入参
     */
    void createOracleApp(CreateOracleApp createOracleApp) throws Exception;

    /**
     * Mysql应用创建并实例化
     *
     * @param createMysqlApp 封装创建Mysql应用所需要的入参
     */
    void createMysqlApp(CreateMysqlApp createMysqlApp) throws Exception;
}
