package com.hzya.frame.nifiapi.operation.impl;

import com.hzya.frame.nifiapi.model.joinsnippetinstance.SnippetInstanceJoin;
import com.hzya.frame.nifiapi.model.joinsnippets.Snippet;
import com.hzya.frame.nifiapi.model.joinsnippets.SnippetsJoin;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.Flow15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.ProcessGroups15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.SnippetInstance15;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.ProcessGroupsInfoResult9;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.Revision9;
import com.hzya.frame.nifiapi.model.resultsnippets.Snippet13;
import com.hzya.frame.nifiapi.model.resultsnippets.SnippetResult13;
import com.hzya.frame.nifiapi.operation.BaseOperation;
import com.hzya.frame.nifiapi.service.NifiApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation.impl
 * @Project：fw-nifi
 * @name：BaseOperationImpl
 * @Date：2025/5/21 18:07
 * @Filename：BaseOperationImpl
 */
@Repository(value = "BaseOperationImpl")
public class BaseOperationImpl implements BaseOperation {

    @Autowired
    private NifiApiService nifiApiService;

    @Override
    public String instantiateApp(String appProcessGroupId, String parentProcessGroupId, String copyTargetProcessGroupId) throws Exception {
        String processGroups15Id = null;
        try {
            //1.创建流程组对应的片段，得到片段id
            //查询目标流程组版本
            ProcessGroupsInfoResult9 processGroups = nifiApiService.getProcessGroups(appProcessGroupId);
            Revision9 revision = processGroups.getRevision();

            Map<String, String> processGroupsMap2 = new HashMap<>();
            processGroupsMap2.put("version", revision.getVersion());//目标流程组版本号

            Map<String, Map<String, String>> processGroupsMap = new HashMap<>();
            processGroupsMap.put(appProcessGroupId, processGroupsMap2);//目标流程组id

            Snippet snippet = new Snippet();
            snippet.setParentGroupId(parentProcessGroupId);//目标流程组id的父流程组id
            snippet.setProcessGroups(processGroupsMap);

            SnippetsJoin snippetsJoin = new SnippetsJoin();
            snippetsJoin.setSnippet(snippet);
            SnippetResult13 snippets = nifiApiService.createSnippets(snippetsJoin);
            Snippet13 snippet1 = snippets.getSnippet();

            //2.将片段实例化到指定位置,得到实例化后的应用id
            ProcessGroupsInfoResult9 processGroups2 = nifiApiService.getProcessGroups(copyTargetProcessGroupId);
            Revision9 revision2 = processGroups2.getRevision();

            Map<String, String> processGroupsMap3 = new HashMap<>();
            processGroupsMap3.put("version", revision2.getVersion());//目标流程组版本号

            Map<String, Map<String, String>> processGroupId = new HashMap<>();
            processGroupId.put(copyTargetProcessGroupId, processGroupsMap3);//目标流程组id

            SnippetInstanceJoin snippetInstanceJoin = new SnippetInstanceJoin();
            snippetInstanceJoin.setSnippetId(snippet1.getId());
            SnippetInstance15 snippetInstance = nifiApiService.createSnippetInstance(copyTargetProcessGroupId, snippetInstanceJoin);
            Flow15 flow = snippetInstance.getFlow();
            ProcessGroups15 processGroups15 = flow.getProcessGroups().get(0);
            processGroups15Id = processGroups15.getId();
        } catch (Exception e) {
            throw new Exception(e);
        }
        return processGroups15Id;
    }
}
