package com.hzya.frame.nifiapi.operation.impl;

import com.hzya.frame.nifiapi.client.NifiClient;
import com.hzya.frame.nifiapi.model.joincreatemysqlapp.CreateMysqlApp;
import com.hzya.frame.nifiapi.model.joincreateoracleapp.CreateOracleApp;
import com.hzya.frame.nifiapi.model.joinsnippetinstance.SnippetInstanceJoin;
import com.hzya.frame.nifiapi.model.joinsnippets.Snippet;
import com.hzya.frame.nifiapi.model.joinsnippets.SnippetsJoin;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.Flow15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.ProcessGroups15;
import com.hzya.frame.nifiapi.model.resultcreatesnippet.SnippetInstance15;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.ProcessGroupsInfoResult9;
import com.hzya.frame.nifiapi.model.resultprocessgroupsinfo.Revision9;
import com.hzya.frame.nifiapi.model.resultsnippets.Snippet13;
import com.hzya.frame.nifiapi.model.resultsnippets.SnippetResult13;
import com.hzya.frame.nifiapi.operation.BaseOperation;
import com.hzya.frame.nifiapi.operation.NifiOperation;
import com.hzya.frame.nifiapi.service.NifiApiService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.Map;

/**
 * NiFi 操作实现类，封装通用操作
 *
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation.impl
 * @Project：fw-nifi
 * @name：NifiOperationImpl
 * @Date：2025/5/21 17:06
 * @Filename：NifiOperationImpl
 */
@Repository(value = "NifiOperationImpl")
public class NifiOperationImpl implements NifiOperation {

    Logger logger = LoggerFactory.getLogger(NifiOperationImpl.class);

    @Autowired
    private NifiApiService nifiApiService;

    @Autowired
    private BaseOperation baseOperation;

    @Override
    public void createOracleApp(CreateOracleApp createOracleApp) throws Exception {
        try {
            //1.实例化Oracle应用
            String appProcessGroupId = createOracleApp.getAppProcessGroupId();
            String appProcessGroupId1 = createOracleApp.getParentProcessGroupId();
            String copyTargetProcessGroupId = createOracleApp.getCopyTargetProcessGroupId();
            String processId = baseOperation.instantiateApp(appProcessGroupId, appProcessGroupId1, copyTargetProcessGroupId);
            logger.info("Oracle应用实例化后的流程组id:{}", processId);
            //2.新增应用对应的上下文参数

        } catch (Exception e) {
            throw new Exception(e);
        }
    }

    @Override
    public void createMysqlApp(CreateMysqlApp createMysqlApp) throws Exception {
        try {
            //1.实例化Mysql应用
            String appProcessGroupId = createMysqlApp.getAppProcessGroupId();
            String appProcessGroupId1 = createMysqlApp.getParentProcessGroupId();
            String copyTargetProcessGroupId = createMysqlApp.getCopyTargetProcessGroupId();
            String processId = baseOperation.instantiateApp(appProcessGroupId, appProcessGroupId1, copyTargetProcessGroupId);
            logger.info("Mysql应用实例化后的流程组id:{}", processId);
        } catch (Exception e) {
            throw new Exception(e);
        }
    }
}
